###############################################################################
# MessageIndex.pl                                                             #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.3                                        #
# Released:       December 2001; Updated April 6, 2003                        #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
###############################################################################

$messageindexplver = "1 Gold - SP 1.3";

sub MessageIndex {
	my $start = int( $INFO{'start'} ) || 0;
	my( $bdescrip, $counter, $buffer, $pages, $showmods, $mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $dlp, $threadlength, $threaddate );
	my( @boardinfo, @threads );
	my( $threadcount, $messagecount, $lastposttime, $lastposter ) = &BoardCountGet($currentboard);
	my $maxindex = $INFO{'view'} eq 'all' ? $threadcount : $maxdisplay;

	# Make sure the starting place makes sense.
	if( $start > $threadcount ) { $start = int( $threadcount % $maxindex ) * $maxindex; }
	elsif( $start < 0 ) { $start = 0; }

	# There are three kinds of lies: lies, damned lies, and statistics. 
	# - Mark Twain
	
$yymain .= qq~
	<script language="JavaScript1.2" type="text/javascript">
		function SelPage(pstart) {
			location.href="$cgi;action=messageindex;start="+pstart;
		}
	</script>
~;
	# Construct the page links for this board.
	my($pageindex);
	$start = ( int( $start / $maxindex ) ) * $maxindex;
	$pagenumb = int(($threadcount - 1) / $maxindex) + 1;
	$lastptn = ($pagenumb - 1) * $maxindex;

	if($pagenumb < 2) {
		$pageindex = 1;
	}
	else {
		$startpage = 0;
		$prevpage = $start - $maxindex;
		$nextpage = $start + $maxindex;
		$pageindex .= qq~$pagenumb &nbsp;~;
		if($start < $maxindex) { $pageindex .= qq~<img src="$imagesdir/none.gif" height="20" width="20" border="0" alt="" vspace="0" hspace="0" align="absmiddle">~; }
		else { $pageindex .= qq~<a href="$cgi;action=messageindex;start=$prevpage"><img src="$imagesdir/prev.gif" height="20" width="20" border="0" alt="" vspace="0" hspace="0" align="absmiddle"></a>~; }
		$pageindex .= qq~<form style="display: inline" method="POST"><select class="catbg" style="width: 55px; font-size: 12px; margin: 0px; padding: 0px; border: 0px" onChange="if(this.options[this.selectedIndex].value) SelPage(this.options[this.selectedIndex].value)">~;
		for($i=1; $i<=$pagenumb; $i++) {
			$selected = "";
			if($start == $startpage) { $selected = " selected" }
			$pageindex .= qq~<option value="$startpage"$selected>$i</option>~;
			$startpage += $maxindex;
		}
		$pageindex .= qq~</select></form>~;
		if($start >= $lastptn) { $pageindex .= qq~<img src="$imagesdir/none.gif" height="20" width="20" border="0" alt="" vspace="0" hspace="0" align="absmiddle">~; }
		else { $pageindex .= qq~<a href="$cgi;action=messageindex;start=$nextpage"><img src="$imagesdir/next.gif" border="0" height="20" width="20" alt="" vspace="0" hspace="0" align="absmiddle"></a>~; }
	}


	# Determine what category we are in.
	fopen(FILE, "$boardsdir/$currentboard.ctb") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.ctb");
	$cat = <FILE>;
	fclose(FILE);
	fopen(FILE, "$boardsdir/$cat.cat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $cat.cat");
	$currcat = $cat;
	$cat = <FILE>;
	fclose(FILE);

	# Get the board's description
	fopen(FILE, "$boardsdir/$currentboard.dat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.dat");
	@boardinfo = <FILE>;
	fclose(FILE);
	chomp @boardinfo;
	$bdescrip = $boardinfo[1];
	#BOARD NEWS START
	$boardnews = $boardinfo[3];
	$boardnews_editinfo = $boardinfo[4];
	$boardnews_output = '';
	$edit_boardnews_link = '';

	if ($boardnews)
	{
		require "$sourcedir/YaBBC.pl";
		$message = $boardnews;
		&DoUBBC;
		$boardnews = $message;

		#last edit info
		($lasteditdate, $lasteditwho) = split(/\|/, $boardnews_editinfo);
		$lasteditwho = lc($lasteditwho);

		fopen(MFILE, "$memberdir/$lasteditwho.dat"); @lines = <MFILE>; fclose(MFILE);
		chomp $lines[1];

		$lasteditdate = &timeformat($lasteditdate) || $lasteditdate;
		$namelink = qq~<a href="$cgi;action=viewprofile;username=$lasteditwho">$lines[1]</a>~;
		foreach (@censored) { ($tmpa,$tmpb) = @{$_}; $boardnews =~ s~\Q$tmpa\E~$tmpb~gi; }

		$boardnews_output = qq~

<!-- BOARD NEWS -->
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">

<table cellpadding="4" cellspacing="1" border="0"><tr>
<td valign="top" width="1%"><img src="$imagesdir/announce.gif" border=0 width=13 height=12 alt="$bn_txt{'1'}" hspace=5></td>
<td valign=top><font size="2">$boardnews</font><br><font size=1>(<i>$lasteditdate $txt{'525'} $namelink</i>)~;
		
		#show the edit news link?
		if (exists $moderators{$username} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator')
			{ $boardnews_output .= qq~&nbsp;(<a href="$cgi;action=editboardnews"><i>$bn_txt{'2'}</i></a>)~; }

		$boardnews_output .= qq~</font></td></tr></table>

        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
~;
	}

	if (exists $moderators{$username} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator')
		{ $edit_boardnews_link = qq~<a href="$cgi;action=editboardnews">$img{'editboardnews'}</a> ~; }
	#BOARD NEWS END

	# Open and quickly read the current board thread list.
	# Skip past threads until we reach the "page" we want.
	fopen(FILE, "$boardsdir/$currentboard.txt") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.txt");
	@threadlist = <FILE>;
	$threadcount = $#threadlist;
	@threadlist2 = '';
	fclose(FILE);

	# Attachment Threads
	fopen(FILE, "$vardir/attachments.txt");
	@attached = <FILE>;
	fclose(FILE);

	# Sticky Threads
	fopen(FILE, "$boardsdir/sticky.stk") || &fatal_error("300 $txt{'106'}: $txt{'23'} sticky.stk");
	@stickys = <FILE>;
	$stickycount = $#stickys;
	fclose(FILE);
	for ($i=0; $i<=$threadcount; $i++) {
		($mnum) = split( /\|/, $threadlist[$i] );
		$l = 0;
		$is = 0;
		foreach $curnum (@stickys) {
			if ($mnum == $curnum) {
				$is = 1;
				$stickylist{$l} = $threadlist[$i];
				#splice(@threadlist,$i,1);
				last;
			}
			$l++;
		}
		if ($is == 0) { push(@threadlist2,$threadlist[$i]); }
	}
	if (!($threadlist2[0])) { shift(@threadlist2); }

	#now sort the stickys
	@stickylist2 = sort {$b <=> $a } keys %stickylist;
	###Next 2 lines Sticky Group mod
	$stkynum = '';
	if($start < $maxdisplay){ $stkynum = scalar @stickylist2; }
	for ($i=0; $i<=$stickycount; $i++) {
		chomp $stickylist{$i};
		if ($stickylist{$i}) { unshift(@threadlist2,"$stickylist{$i}\n"); }
	}

	$counter = 0;
	$tmpa = '';
	if($counter < $start && ($buffer = $threadlist2[$counter])) {
		$tmpa = $buffer;
		$counter++;
	}
	while($counter < $start && ($buffer = $threadlist2[$counter])) { $counter++; }

	$#threads = $maxindex - 1;
	$curln = $counter;
	$counter = 0;
	while( $counter < $maxindex && ( $buffer = $threadlist2[$curln+$counter] ) ) {
		chomp $buffer;
		$threads[$counter] = $buffer;
		$counter++;
	}
	$#threads = $counter - 1;

	# Let's get the info for the first thread in this forum.
	$tmpa ||= $threads[0];
	($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split( /\|/, $tmpa );

	# Mark current board as seen.
	&dumplog($currentboard);

	# Build a list of the board's moderators.
	if( scalar keys %moderators > 0 ) {
		if( scalar keys %moderators == 1 ) { $showmods = qq~($txt{'298'}: ~; }
		else { $showmods = qq~($txt{'299'}: ~; }
		while( $_ = each(%moderators) ) {
			&FormatUserName($_);
			$showmods .= qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$_}" class="nav">$moderators{$_}</a>, ~;
		}
		$showmods =~ s/, \Z/)/;
	}

	$notify = '';
	# Update notification file that the board has been viewed.
	if($enable_board_notify && $username ne 'Guest') {
		$notify = qq~$menusep<a href="$cgi;action=notify2" onclick="javascript:return confirm('$bln_txt{'03'}')" class="altlink">$img{'notify_b'}</a>~;
		if(-e("$boardsdir/$currentboard.mail"))  {
			my $i = 0;
			my $found = 0;
			fopen(FILE, "$boardsdir/$currentboard.mail");
			@mails = <FILE>;
			fclose(FILE);
			foreach $curmail (@mails) {
				chomp $curmail;
				($curmail, $mail_sent, $notify_type) = split(/\|/,$curmail);
				if ($curmail eq $settings[2]) {
					$notify = qq~$menusep<a href="$cgi;action=notify3" onclick="javascript:return confirm('$bln_txt{'04'}')" class="altlink">$img{'notify_b'}</a>~;
					if ($mail_sent == 1) {$mail_sent = 0; $found = 1;}
				}
				$mails[$i] = "$curmail|$mail_sent|$notify_type\n";
				$i++;
			}
			if ($found == 1) {
				fopen(FILE, ">$boardsdir/$currentboard.mail");
				print FILE @mails;
				fclose(FILE);
			}
		}
	}

	# Load censor list.
	fopen(FILE,"$vardir/censor.txt");
	while( chomp( $buffer = <FILE> ) ) {
		($tmpa,$tmpb) = split(/=/,$buffer);
		push(@censored,[$tmpa,$tmpb]);
	}
	fclose(FILE);

	# Print the header and board info.
	$curboardurl = $curposlinks ? qq~<a href="$cgi" class="nav">$boardname</a>~ : $boardname;
	if((exists $moderators{$username} && $modview == 1) || ($settings[7] eq 'Administrator' && $adminview == 1) || ($settings[7] eq 'Global Moderator' && $gmodview == 1)) {
		$yymain .= qq~<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>~;
	}
	$yymain .= qq~
<table width="100%" cellpadding="0" cellspacing="0">
  <tr>
    <td><font size="2" class="nav"><b>
    <IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;
    <a href="$scripturl" class="nav">$mbname</a><br>
    <IMG SRC="$imagesdir/tline.gif" BORDER=0><IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;
    <a href="$scripturl#$currcat" class="nav">$cat</a><br>
    <IMG SRC="$imagesdir/tline2.gif" BORDER=0><IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;
    $curboardurl</b> <font size="1">$showmods</font></font></td>
  </tr>
</table>
~;
if (($settings[7] eq 'Administrator' && $adminview >= 2) || ($settings[7] eq 'Global Moderator' && $gmodview >= 2) || (exists $moderators{$username} && $modview >= 2)){
	$multiadmin = qq~<form name="multiadmin" action="$scripturl?board=$currentboard;action=multiadmin" method="POST" style="display: inline">~;
	$endmultiadmin = qq~</form>~;
}
if($ShowBDescrip && $bdescrip ne "") {
$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
        <table cellpadding="3" cellspacing="0" width="100%">
          <tr>
            <td width="100%"><font size="1">$bdescrip</font></td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
~;
}
$yymain .= qq~
$boardnews_output
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
        <table cellpadding="3" cellspacing="0" width="100%">
          <tr>
            <td><font size=2><b>$txt{'139'}:</b> $pageindex</font></td>
	    <td class="catbg" bgcolor="$color{'catbg'}" align=right nowrap><font size=-1>$edit_boardnews_link
~;
	if ($username ne 'Guest') {
if($showmarkread) {
	$yymain .= qq~<a href="$cgi;action=markasread">$img{'markboardread'}</a>~;
}
if($enable_board_notify) {
	$yymain .= $notify;
}
}
	$yymain .= qq~
	    $menusep<a href="$cgi;action=post;title=$txt{'464'}">$img{'newthread'}</a>$menusep<a href="$cgi;action=post;title=$polltxt{'1a'}">$img{'createpoll'}</a>&nbsp;
	    </font></td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
$multiadmin
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="10%" colspan="2"><font size="2">&nbsp;</font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="44%"><font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'70'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="14%" align="center"><font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'109'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="4%" align="center"><font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'110'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="4%" align="center"><font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'301'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="24%"><font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'111'}</b></font></td>
~; 
if (($settings[7] eq 'Administrator' && $adminview == 3) || ($settings[7] eq 'Global Moderator' && $gmodview == 3) || (exists $moderators{$username} && $modview == 3)){ 
      $yymain .= qq~ 
       <td class="titlebg" bgcolor="$color{'titlebg'}" width="20%" align="center" nowrap> <img src="$imagesdir/locked.gif" alt="$txt{'104'}" border="0">   
<img src="$imagesdir/sticky.gif" alt="$txt{'781'}" border="0">   
<img src="$imagesdir/admin_move.gif" alt="$txt{'132'}" border="0">  
<img src="$imagesdir/admin_rem.gif" alt="$txt{'63'}" border="0"></td>  
      ~; 
} 
elsif (($settings[7] eq 'Administrator' && $adminview != 0) || ($settings[7] eq 'Global Moderator' && $gmodview != 0) || (exists $moderators{$username} && $modview != 0)){ 
      $yymain .= qq~ 
       <td class="titlebg" bgcolor="$color{'titlebg'}" width="20%" align="center"><font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'2'}</b></font></td> 
      ~; 
} 
$yymain .= qq~ 
      </tr>
~;

###Start Sticky Group mod
if($stkynum){
	$yymain .= qq~
      <tr>
        <td colspan="8" align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%"><font size="2"><b>&nbsp;$stickygrp{'1'}</b></font></td>
      </tr>
~;
}
###End Sticky Group mod

	# Begin printing the message index for current board.
	$counter = $start;
	foreach( @threads ) {
		($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split( /\|/, $_ );
		# Set thread class depending on locked status and number of replies.
		$threadclass = 'thread';
		if( $mstate == 1 ) { $threadclass = 'locked'; }
		elsif( $mreplies > 49 ) { $threadclass = 'veryhotthread'; }
		elsif( $mreplies > 24 ) { $threadclass = 'hotthread'; }
		elsif( $mstate == 0 ) { $threadclass = 'thread'; }
		foreach $curnum (@stickys) {
			if ($mnum == $curnum) {
				if($threadclass eq 'locked') { $threadclass = 'stickylock'; }
				else { $threadclass = 'sticky'; }
			}
		}

		$showicon = $micon;
		# Decide if thread should have the "NEW" indicator next to it.
		# Do this by reading the user's log for last read time on thread,
		# and compare to the last post time on the thread.
		## LAST READ MOD ##
		$stuff = &getlog($mnum);
		($dlp, $lastread) = split( /\|/, $stuff );
		if ($lastread ne '') { $lastread = qq~;start=$lastread#$lastread~;}
		## /LAST READ MOD ##
		$threaddate = stringtotime($mdate);
		if( $max_log_days_old && $dlp < $threaddate && $username ne 'Guest' && &getlog("$currentboard--mark") < $threaddate ) {
			## LAST READ MOD ##
			$new = qq~<a href="$cgi;action=display;num=$mnum$lastread"><img src="$imagesdir/new.gif" border="0" alt="$txt{'302a'}"></a>~; 
			## /LAST READ MOD ##
		}
		else { $new = ''; }

		# Load the current nickname of the account name of the thread starter.
		$micon = qq~<img src="$imagesdir/$micon.gif" alt="" border="0" align="middle">~;
		$mpoll = "";
		if (-e "$datadir/$mnum.poll") {
			$mpoll = qq~<b>$polltxt{'15'}: </b>~;
			fopen (FILE, "$datadir/$mnum.poll");
			$poll_question = <FILE>; 
			fclose (FILE);
			chomp $poll_question;
			($dummy, $poll_locked, $dummy) = split(/\|/, $poll_question, 3);
			$micon = qq~$img{'pollicon'}~;
			if ($poll_locked) { $micon = $img{'polliconclosed'}; }
			else {
				fopen(FILE, "$datadir/$mnum.polled");
				$polled = <FILE>;
				fclose(FILE);
				$dlp = &getlog($mnum);
				($dummy, $dummy, $dummy, $vote_date, $dummy) = split(/\|/, $polled);
				$vote_date = stringtotime($vote_date);
				if( $max_log_days_old && $dlp < $vote_date && $username ne 'Guest' && &getlog("$currentboard--mark") < $vote_date ) {$micon = qq~$img{'polliconnew'}~;}
			}
		}

		if( $musername ne 'Guest' && -e "$memberdir/$musername.dat" ) {
			&LoadUser($musername);
			$mname = $userprofile{$musername}->[1] || $mname || $txt{'470'};
			$mname = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}">$mname</a>~;
		}
		else {
			$mname ||= $txt{'470'};
		}

		# Censor the subject of the thread.
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}

		# Decide how many pages the thread should have.
		$threadlength = $mreplies + 1;
		$pages = '';
		if( $threadlength > $maxmessagedisplay ) { 
			$tmpa = 1;
			$count = 0; 
			for( $tmpb = 0; $tmpb < $threadlength && $count < 3; $tmpb += $maxmessagedisplay ) { 
				$pages .= qq~<a href="$cgi;action=display;num=$mnum;start=$tmpb#$tmpb">$tmpa</a>\n~; 
				++$tmpa;
				++$count;
			} 
			$tmpaend = int($threadlength/$maxmessagedisplay+0.99); 
			$tmpbend = $maxmessagedisplay*$tmpaend-$maxmessagedisplay; 
			if( $tmpaend > 3) { $pages .= qq~...<a href="$cgi;action=display;num=$mnum;start=$tmpbend#$tmpbend">$tmpaend</a >\n~; } 
			$pages =~ s/\n\Z//; 
			$pages = qq~<BR><font size="1">&#171; $txt{'139'} $pages <A href="$cgi;action=display;num=$mnum;start=all">$pidtxt{'01'}</a> &#187;</font>~; 
		}

		if(fopen(FILE, "$datadir/$mnum.data")) {
			$tmpa = <FILE>;
			@other_stuff = <FILE>;
			fclose(FILE);
			chomp $tmpa;
		}
		elsif( -e "$datadir/$mnum.data" ) {
			&fatal_error("301 $txt{'106'}: $txt{'23'} $mnum.data");
		}
		else {
			$tmpa = '0';
		}


		($views, $lastposter) = split(/\|/, $tmpa);
		if( $lastposter =~ m~\AGuest-(.*)~ ) {
			$lastposter = $1;
		}
		else {
			unless( $lastposter eq $txt{'470'} ) {
				$lastposterid = $lastposter;
				&LoadUser($lastposterid);
				if($userprofile{$lastposter}->[1]) { $lastposter = qq~<a href="$scripturl?action=viewprofile;username=$lastposterid">$userprofile{$lastposter}->[1]</a>~; }
			}
			&LoadUser($lastposter);
		}
		$lastpostername = $lastposter || $txt{'470'};
		$views = $views ? $views - 1 : 0;

		if ($userprofile{$musername}->[7] eq 'Administrator' && $showicon eq "lamp"){$backbg = "announcebg"; }
		elsif ($userprofile{$musername}->[7] eq 'Administrator' && $showicon eq "exclamation"){$backbg = "adminbg"; }
		else {$backbg = "windowbg2"; }

###Start Sticky Group mod
if(($stkynum && ($counter >= $stkynum)) && ($stkyshowed < 1)){
	$yymain .= qq~
      <tr>
        <td colspan="8" align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%"><font size="2"><b>&nbsp;$stickygrp{'2'}</b></font></td>
      </tr>
~;
$stkyshowed = 1;
}
###End Sticky Group mod

		# Has Image Indicator
		fopen(FILE, "$datadir/$mnum.txt");
			@starter = <FILE>;
		fclose(FILE);
		$has_img = '';
		$has_attach = '';
		foreach $alx (@starter) {
			if($alx =~ /img\]/i) {$has_img = qq~ &nbsp;<img src="$imagesdir/has_img.gif" alt="" align="middle">~;}
		}
		foreach $alx (@attached) { 
			my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$alx);
			if($mnum eq $amthreadid) { 
				if(($amfn =~ /(jpg|gif|bmp|png|jpeg)$/i) && ($amdisplaypics == 1)) { 
					$has_img = qq~ &nbsp;<img src="$imagesdir/has_img.gif" alt="" align="middle">~; 
				} else {  
					$has_attach = qq~ &nbsp;<img src="$imagesdir/paperclip.gif" alt="" align="middle">~; 
				} 
			} 
		} 

		# Print the thread info.
		$mydate = &timeformat($mdate);
		$yymain .= qq~
      <tr>
        <td class="$backbg" valign="middle" align="center" width="6%"><img src="$imagesdir/$threadclass.gif"></td>
        <td class="windowbg2" valign="middle" align="center" width="4%" bgcolor="$color{'windowbg2'}">$micon</td>
        <td class="windowbg" valign="middle" width="44%" bgcolor="$color{'windowbg'}"><font size="2">$new $mpoll<a href="$cgi;action=display;num=$mnum"><b>$msub</b></a> $pages$has_img$has_attach</font></td>
        <td class="$backbg" valign="middle" align="center" width="14%"><font size="1">$mname</font></td>
        <td class="windowbg" valign="middle" width="4%" align="center"><font size="2">$mreplies</font></td>
        <td class="windowbg" valign="middle" width="4%" align="center"><font size="2">$views</font></td>
        <td class="$backbg" valign="middle" width="24%"><font size="1">$mydate<br>$txt{'525'} $lastpostername</font></td>
~;
if (($settings[7] eq 'Administrator' && $adminview == 3) || ($settings[7] eq 'Global Moderator' && $gmodview == 3) || (exists $moderators{$username} && $modview == 3)){
	$yymain .= qq~
        <td class="catbg" bgcolor="$color{'catbg'}" valign="middle" width="20%" align="center" nowrap><input type="checkbox" name="lockadmin$mcount" value="$mnum">
        <input type="checkbox" name="stickadmin$mcount" value="$mnum">
        <input type="checkbox" name="moveadmin$mcount" value="$mnum">
        <input type="checkbox" name="deleteadmin$mcount" value="$mnum"></td>
        ~;
}
elsif (($settings[7] eq 'Administrator' && $adminview == 2) || ($settings[7] eq 'Global Moderator' && $gmodview == 2) || (exists $moderators{$username} && $modview == 2)){
	$yymain .= qq~
        <td class="catbg" bgcolor="$color{'catbg'}" valign="middle" width="20%" align="center"><input type="checkbox" name="admin$mcount" value="$mnum"></td>
        ~;
}
elsif (($settings[7] eq 'Administrator' && $adminview == 1) || ($settings[7] eq 'Global Moderator' && $gmodview == 1) || (exists $moderators{$username} && $modview == 1)){
	$yymain .= qq~
        <td class="catbg" bgcolor="$color{'catbg'}" valign="middle" width="20%" align="center">
            <a href="$cgi;action=lock;thread=$mnum"><img src="$imagesdir/locked.gif" alt="$txt{'104'}" border="0"></a>&nbsp;
            <a href="$cgi;action=sticky;thread=$mnum"><img src="$imagesdir/sticky.gif" alt="$txt{'781'}" border="0"></a>&nbsp;
            <a href="$cgi;action=movethread;thread=$mnum"><img src="$imagesdir/admin_move.gif" alt="$txt{'132'}" border="0"></a>&nbsp;
            <a href="javascript:DoConfirm('$txt{'162'}','$cgi;action=removethread;thread=$mnum')"><img src="$imagesdir/admin_rem.gif" alt="$txt{'63'}" border="0"></a>
        </td>
        ~;
}
$yymain .= qq~
      </tr>
~;
		++$counter;
		$mcount++;
	}

	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);
	$boardlist="";
	foreach $curcat (@categories) {
		$curcat =~ s/[\n\r]//g;
		fopen(CAT, "$boardsdir/$curcat.cat");
		@catinfo = <CAT>;
		fclose(CAT);
		$catinfo[1] =~ s/[\n\r]//g;
		$curcatname="$catinfo[0]";
		boardcheck: foreach $curboard (@catinfo) {
			$curboard =~ s/[\n\r]//g;
			fopen(BOARD, "$boardsdir/$curboard.dat");
			@boardinfo = <BOARD>;
			fclose(BOARD);
			chomp @boardinfo;
			$curboardname = $boardinfo[0];
			if($curboard ne "$catinfo[0]" && $curboard ne "$catinfo[1]" && $currentboard ne $curboard) {
				$curboard =~ s/[\n\r]//g;

				$boardlist .= "<option value=\"$curboard\">$curboardname";
			}
		}
	}
if ($enable_topicrating == 1) {$colspan=8;} else {$colspan=7;}
if (($settings[7] eq 'Administrator' && $adminview == 3) || ($settings[7] eq 'Global Moderator' && $gmodview == 3) || (exists $moderators{$username} && $modview == 3)){
	$yymain .= qq~
        <tr>
          <td class="catbg" bgcolor="$color{'catbg'}" valign="middle" align="right" colspan="$colspan"><font size="1">$txt{'133'}: <select name="toboard">$boardlist</select>	
	    <input type=submit value="$txt{'462'}">
            &nbsp; <i>$txt{'737'}</i></font>
          </td>
          <td class="catbg" bgcolor="$color{'catbg'}" valign="middle" align="center" nowrap>
              <INPUT TYPE="checkbox" name="lockall" value="" ONCLICK="if (this.checked) checkAll(1); else uncheckAll(1);">
              <INPUT TYPE="checkbox" name="stickall" value="" ONCLICK="if (this.checked) checkAll(2); else uncheckAll(2);">
              <INPUT TYPE="checkbox" name="moveall" value="" ONCLICK="if (this.checked) checkAll(3); else uncheckAll(3);">
              <INPUT TYPE="checkbox" name="deleteall" value="" ONCLICK="if (this.checked) checkAll(4); else uncheckAll(4);">
          </td>  
        </tr>
        ~;
}
elsif (($settings[7] eq 'Administrator' && $adminview == 2) || ($settings[7] eq 'Global Moderator' && $gmodview == 2) || (exists $moderators{$username} && $modview == 2)){
	$yymain .= qq~
        <tr>
          <td class="catbg" bgcolor="$color{'catbg'}" colspan="$colspan" valign="middle" align="right"><font size="1">
            <input type="radio" name="action" value="lock" checked> $txt{'104'} &nbsp; 
	    <input type="radio" name="action" value="stick"> $txt{'781'} &nbsp; 
	    <input type="radio" name="action" value="delete"> $txt{'31'} &nbsp; 
	    <input type="radio" name="action" value="move"> $txt{'133'}: <select name="toboard">$boardlist</select>	
	    <input type=submit value="$txt{'462'}">
            &nbsp; <i>$txt{'737'}</i></font>
          </td>
          <td class="catbg" bgcolor="$color{'catbg'}" valign="middle" align="center"><INPUT TYPE="checkbox" name="checkall" value="" ONCLICK="if (this.checked) checkAll(0); else uncheckAll(0);"></td>  
        </tr>
~;
}

	$yymain .= qq~
    </table>
    </td>
  </tr>
</table>
$endmultiadmin
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
        <table cellpadding="3" cellspacing="0" width="100%">
          <tr>
            <td><font size=2><b>$txt{'139'}:</b> $pageindex</font></td>
	    <td class="catbg" bgcolor="$color{'catbg'}" align=right nowrap><font size="2">$edit_boardnews_link
~;
	if ($username ne 'Guest') {
	if($showmarkread) { $yymain .= qq~<a href="$cgi;action=markasread">$img{'markboardread'}</a>~; }
	if($enable_board_notify) { $yymain .= $notify; }
}
	&jumpto;
	$yymain .= qq~
	    $menusep<a href="$cgi;action=post;title=$txt{'464'}">$img{'newthread'}</a>$menusep<a href="$cgi;action=post;title=$polltxt{'1a'}">$img{'createpoll'}</a>&nbsp;
	    </font></td>
	  </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table><br>
~;
if (($settings[7] eq 'Administrator' && $adminview >= 2) || ($settings[7] eq 'Global Moderator' && $gmodview >= 2) || (exists $moderators{$username} && $modview >= 2)) {

	if (($settings[7] eq 'Administrator' && $adminview == 3) || ($settings[7] eq 'Global Moderator' && $gmodview == 3) || (exists $moderators{$username} && $modview == 3)) { $offset="6"; }
	else { $offset="7"; }
	$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!-- Begin
function checkAll(j) {
  for (var i = 0; i < document.multiadmin.elements.length - $offset; i++) {
  	if(document.multiadmin.elements[i].name != "subfield" && document.multiadmin.elements[i].name != "msgfield") {
		if (j == 0 ) {document.multiadmin.elements[i].checked = true;}
		if (j != 0 && (i % 4) == (j - 1))  {document.multiadmin.elements[i].checked = true;}
    	}
  }
}
function uncheckAll(j) {
  for (var i = 0; i < document.multiadmin.elements.length - $offset; i++) {
  	if(document.multiadmin.elements[i].name != "subfield" && document.multiadmin.elements[i].name != "msgfield") {
		if (j == 0 ) {document.multiadmin.elements[i].checked = false;}
		if (j != 0 && (i % 4) == (j - 1))  {document.multiadmin.elements[i].checked = false;}
    	}
  }
}
//-->
</script>
	~;
}
$yymain .= qq~
<table cellpadding=0 cellspacing=0 width="100%">
  <tr>
    <form action="$scripturl?action=search2" method="post" name="searchform">
    <td align="center" colspan="3"><font size=1>
	<b>$brdsrch{'1'}:&nbsp;<input type=text size=30 name="search"> 
	<input type=hidden name="subfield" value=on>
	<input type=hidden name="msgfield" value=on>
        $brdsrch{'2'}<input type=text name="maxage" value=7 size=3 maxlength=3> $txt{'579'}.
	<input type=hidden name="brd1" value="$currentboard">
        <input type=hidden name=action value=dosearch>
        $brdsrch{'3'}:&nbsp;<input type=text size=3 name=numberreturned maxlength=3 value=10></b></font>
	<input type=hidden name="srchbrd" value=1>
        <input type="submit" name="submit" value="$txt{'182'}"><br><br>
    </td></form>
  </tr>
  <tr>
	<td align="left" valign="middle"><font size="1">
	<img src="$imagesdir/thread.gif"> $txt{'457'}<BR>
	<img src="$imagesdir/hotthread.gif"> $txt{'454'}<BR>
	<img src="$imagesdir/veryhotthread.gif"> $txt{'455'}
	</font></td><td align="left" valign="middle"><font size="1">
	<img src="$imagesdir/locked.gif"> $txt{'456'}<BR>
	<img src="$imagesdir/sticky.gif"> $txt{'779'}<BR>
	<img src="$imagesdir/stickylock.gif"> $txt{'780'}
	</font></td>
	<td align="right" valign="middle"><font size="1">$selecthtml</font></td>
  </tr>
</table>
~;
### Quick Reply Box 1.3 ###

	# MBCO2 Post access check
	if ($start_users{$currentboard} || $start_groups{$currentboard}) {
		my $access = &AccessCheck($currentboard, 1) || "";
		if ($access eq "denied") {$enable_quickpost = 0;}
	}

	if ($username ne "Guest" && $enable_quickpost == 1) {
$yymain .= qq~
<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
<form action="$cgi;action=post2" method="post" name="postmodify" onsubmit="postmodify.post.disabled=true; postmodify.clear.disabled=true;">
<input type="hidden" name="threadid" value="">
<input type="hidden" name="icon" value="xx">
<table border=0 width="80%" cellspacing="1" cellpadding="4" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td align="center" class="titlebg" bgcolor="$color{'titlebg'}"><font size="2" class="text1" color="$color{'titletext'}"><b>$qrb_txt{'1'}</b></font></td>
  </tr>
  <tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
      <table width="100%" cellpadding="4" cellspacing="0">
        <tr>
          <td valign="top" width="23%"><font size="2"><b>$txt{'70'}:</b></font></td>
          <td><font size="2"><input type="text" name="subject" value="" size="40" style="width:100%"></td>
        </tr>~;
		if ($enable_quicksmilies == 1) {
			if ($smiliestyle eq 1){$smiliewinlink = "$scripturl?action=smilieput";} else { $smiliewinlink = "$scripturl?action=smilieindex";}
			$moresmilieslist = ""; 
			$more_smilie_array = ""; 
			$i=0; 
			if ($showadded eq 1){ # show added smilies on smiley bar
				while($SmilieURL[$i]) { 
					if ($SmilieURL[$i]=~ /\//i) {$tmpurl = $SmilieURL[$i];} else {$tmpurl = qq~$imagesdir/$SmilieURL[$i]~;}
					$moresmilieslist .= qq~      document.write("<img src='$tmpurl' align='bottom' alt="+'"'+"$SmilieDescription[$i]"+'"'+" border='0' onclick='javascript:MoreSmilies($i)' style='cursor:hand'>$SmilieLinebreak[$i] ");\n~; 
					$tmpcode = $SmilieCode[$i];
					$tmpcode =~ s/\&quot;/"+'"'+"/g;
					&FromHTML($tmpcode);
					$tmpcode =~ s/&#36;/\$/g;
					$tmpcode =~ s/&#64;/\@/g;
					$more_smilie_array .= qq~" $tmpcode", ~; 
					$i++; 
				} 
			}
			if ($showsmdir eq 1){ # show auto smilies on smiley bar
				opendir(DIR, "$smiliesdir"); 
				@contents = readdir(DIR); 
				closedir(DIR); 
				foreach $line (sort {uc($a) cmp uc($b)} @contents){ 
					($name, $extension) = split (/\./, $line); 
					if ($extension =~ /gif/i || $extension =~ /jpg/i || $extension =~ /jpeg/i || $extension =~ /png/i ){ 
						if ($line !~ /banner/i) { 
							$moresmilieslist .= qq~      document.write("<img src='$smiliesurl/$line' align='bottom' alt='$name' border='0' onclick='javascript:MoreSmilies($i)' style='cursor:hand'> ");\n~; 
							$more_smilie_array .= qq~" [smiley=$line]", ~; 
							$i++ 
						} 
					} 
				} 
			}
			$more_smilie_array .= qq~""~; 
			$yymain .= qq~
        <tr>
          <td valign="top" width="23%"><font size="2"><b>$txt{'297'}:</b></font></td>
          <td valign="middle">
          <script language="JavaScript1.2" type="text/javascript">
          <!--
            moresmiliecode = new Array($more_smilie_array) 

            function MoreSmilies(i) { 
              AddTxt=moresmiliecode[i]; 
              AddText(AddTxt); 
            }

            function smiliewin() {
              window.open("$smiliewinlink", 'list', 'width=$winwidth,height=$winheight, scrollbars=yes');
            }
  
            if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4)) {
              document.write("<img style='cursor:hand' onclick='javascript:smiley()' src='$imagesdir/smiley.gif' align='bottom' alt='$txt{'287'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:wink()' src='$imagesdir/wink.gif' align='bottom' alt='$txt{'292'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:cheesy()' src='$imagesdir/cheesy.gif' align='bottom' alt='$txt{'289'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:grin()' src='$imagesdir/grin.gif' align='bottom' alt='$txt{'293'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:angry()' src='$imagesdir/angry.gif' align='bottom' alt='$txt{'288'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:sad()' src='$imagesdir/sad.gif' align='bottom' alt='$txt{'291'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:shocked()' src='$imagesdir/shocked.gif' align='bottom' alt='$txt{'294'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:cool()' src='$imagesdir/cool.gif' align='bottom' alt='$txt{'295'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:huh()' src='$imagesdir/huh.gif' align='bottom' alt='$txt{'296'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:rolleyes()' src='$imagesdir/rolleyes.gif' align='bottom' alt='$txt{'450'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:tongue()' src='$imagesdir/tongue.gif' align='bottom' alt='$txt{'451'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:embarassed()' src='$imagesdir/embarassed.gif' align='bottom' alt='$txt{'526'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:lipsrsealed()' src='$imagesdir/lipsrsealed.gif' align='bottom' alt='$txt{'527'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:undecided()' src='$imagesdir/undecided.gif' align='bottom' alt='$txt{'528'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:kiss()' src='$imagesdir/kiss.gif' align='bottom' alt='$txt{'529'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:cry()' src='$imagesdir/cry.gif' align='bottom' alt='$txt{'530'}' border='0'> ");
$moresmilieslist
            }
            else { document.write("<font size='1'>$txt{'215'}</font>"); }
          //-->
          </script>~;
		if ($showadded == 3 || ($showadded == 2 && $detachblock == 1) || $showsmdir == 3 || ($showsmdir == 2 && $detachblock == 1)){
			$yymain .= qq~
          <a href=javascript:smiliewin()>$smiltxt{'1'}</a>~;
		}
		$yymain .= qq~ 
          <noscript>
            <font size="1">$txt{'215'}</font>
          </noscript>
          </td>
        </tr>~;
		}
	$yymain .= qq~
        <tr>
          <td valign="top" width="23%"><font size="2"><b>$txt{'72'}:</b></font></td>
          <td><textarea name="message" rows="5" cols="60" wrap="soft" ONCLICK="javascript:storeCaret(this);" ONKEYUP="javascript:storeCaret(this);" ONCHANGE="javascript:storeCaret(this);" style="width:100%"></textarea></td>
        </tr>
      </table>
    </td>
  </tr>
  <tr>
    <td align="center" class="catbg" bgcolor="$color{'catbg'}"><input type="submit" name="post" value="$txt{'105'}" accesskey="s"> &nbsp; <input type="reset" name="clear" value="$txt{'278'}" accesskey="r"></td>
  </tr>
</table>
</form>
~;
	}

### Quick Reply Box 1.3 ###

	$yytitle = $boardname;
	&template;
	exit;
}

sub MarkRead {
	# Mark all threads in this board as read.
	&dumplog("$currentboard--mark");
	$yySetLocation = qq~$scripturl~;
	&redirectexit;
}

1;